#!/bin/bash

############################
# horus.sh
# instructions spécifiques au module Horus
############################

# Appel Bibliothèque
. ParseDico

if [ -e /var/lib/ldap/cn.bdb ]
then
        echo ""
        echo "Voulez vous re-générer l'annuaire LDAP ? (Oui/Non)"
        echo "Attention, cela detruira l'existant !"
        read Rep
else
        Rep="oui"
fi

if [ ! -e /etc/ssl/horus/server.crt ]
then
        echo -e "\n## génération du certificat Horus ##"
        /usr/share/eole/gen_certifHorus.sh
fi

echo -e "\n## gestion du mot de passe LDAP ##"
/usr/share/eole/ldap_pwd.py `/usr/bin/pwgen -1` > /dev/null

echo -e "\n## gestion du SID ##"
/usr/share/eole/set_sid.sh

if [ "$Rep" == "oui" -o "$Rep" == "Oui" -o "$Rep" == "o" -o "$Rep" == "O" ]
then
        echo -e "\n## Initialisation de l'annuaire ##"
        /usr/share/eole/gen_ldap.sh > /dev/null
        # FIXME : bug au 1er démarrage avec samba-3.0.22
        /etc/init.d/samba start &> /dev/null

	## gestion des utilisateurs et groupes
	echo -e "\n## Ajout de l'utilisateur admin ##"
	python -c "from horus import backend; backend.add_user('admin', 'DomainUsers', ['DomainAdmins', 'PrintOperators'])"
        res=1
        while [ "$res" -ne 0 ];do
                smbldap-passwd admin
                res=$?
        done
	ln -nsf /home/esu /home/admin/perso/esu
	python -c "from horus.backend import add_group; add_group('applidos'); add_group('minedu')"
	python -c "from horus.backend import add_share; add_share('applidos', 'applidos', filepath='/data/applidos', sticky=True, sync=False, drive='F:')"
	python -c "from horus.backend import add_share; add_share('minedu', 'minedu', filepath='/data/minedu', sticky=True, sync=False, drive='X:')"
	# partage "groupes"
	python -c "from horus.backend import add_share; add_share('groupes', 'DomainUsers', filepath='%H/groupes', drive='S:', sync=False)"
	python -c "from horus.backend import add_share; add_share('icones$', 'DomainUsers', filepath='/home/netlogon/icones', drive='R:', sync=False)"
fi

## synchronisation du fichier smb.conf
/usr/share/horus/synchro-file.py norestart

echo

## lancement firewall
/usr/sbin/lance.firewall

# creation des repertoires au 1er demarrage de mars
if [ ! -d /data/tmp ];then
	/etc/init.d/mars-nwe start > /dev/null
fi

# FIXME : manage-horus (edgy -> .bash_profile)
grep -q  "manage-horus" /home/horus/.profile
if [ $? -ne 0 ];then
        echo "exec /usr/share/eole/manage-horus.sh" >> /home/horus/.profile
fi

## FIXME ##
sed -i".bak" '/www-data/d' /etc/at.deny

## FIXME ##
ln -snf /etc/apache2/mods-available/ssl.load /etc/apache2/mods-enabled/
ln -sfn /etc/apache2/mods-available/ldap.load /etc/apache2/mods-enabled/
ln -sfn /etc/apache2/mods-available/authnz_ldap.load /etc/apache2/mods-enabled/

# Bacula
[ ! -e /etc/bacula/eoleschedule.conf ] && touch /etc/bacula/eoleschedule.conf
[ ! -e /etc/bacula/typesupport.conf ] && /usr/share/eole/bacula/baculasupport.py -s distant 1>/dev/null
[ ! -e /etc/bacula/listefichiersperso.conf ] && touch /etc/bacula/listefichiersperso.conf
[ ! -e /etc/bacula/listefichiersexperso.conf ] && touch /etc/bacula/listefichiersexperso.conf

