#!/usr/bin/env python
# -*- coding: UTF-8 -*-

# Mise à jour du mot de passe LDAP 
# Horus-2.0
# Equipe Eole eole@ac-dijon.fr

import os, sys

# liste des fichiers concernés par le mot de passe LDAP
modifs = {'/etc/ldap/slapd.conf':'rootpw ',
          '/etc/smbldap-tools/smbldap_bind.conf':('masterPw="','slavePw="'),
          '/usr/share/eole/gen_ldap.sh':'PASSWD="',
          '/usr/share/python-support/python-horus-backend/horus/backend_conf.py':'ldap_passwd = "'
         }

# on demande le nouveau mot de passe
# si il n'est pas passé comme paramètre
try:
    new_pass = sys.argv[1]
except:
    new_pass = ""
    while len(new_pass) < 5:
        if new_pass != "":
            print "le mot de passe est trop court (5 caractères au moins)"
        new_pass = raw_input("\nNouveau mot de passe pour l'admin LDAP ? ")

# récupération du mot de passe crypté
cmd = "/usr/sbin/slappasswd -s %s" % new_pass
entree,sortie = os.popen2(cmd)
res = sortie.read()
crypt_pwd = res.strip()

# parcours du dictionnaire
for file_path in modifs.keys():

    chaines_recherche = modifs[file_path]
    # compatibilité ancienne version
    if type(chaines_recherche) != tuple :
        chaines_recherche=(chaines_recherche,)
	
    for chaine_recherche in chaines_recherche:
	    
        # lecture du fichier de conf
        conf_file = open(file_path,"r")
        print "\nMise à jour du fichier "+file_path+".."
        buffer_in=conf_file.readlines()
        conf_file.close()

        buffer_out = ""
        # on parcourt le fichier
        for line in buffer_in:
            # si la ligne actuelle contient la chaine recherchée
            if line.startswith(chaine_recherche):
                print "définition du mot de passe trouvée : "+line.strip()
                buffer_out += chaine_recherche
                if file_path in ["/etc/ldap/slapd.conf"]:
                    buffer_out += crypt_pwd
                else:
                    buffer_out += new_pass
                if chaine_recherche.endswith('"'):
                    # si le mot de passe est entre guillemets, on ajoute le guillemet fermant
                    buffer_out += '"'
                if file_path.endswith('.pl') or file_path.endswith('.pm') or file_path.endswith('.php'):
                    buffer_out += ';'
                buffer_out += "\n"
            else:
                # sinon, on recopie la ligne d'origine
                buffer_out+=line
            
        # sauvegarde du fichier de conf
        conf_file = open(file_path,"w")
        conf_file.write(buffer_out)
        conf_file.close()

# mise à jour du mot de passe pour samba
print "\nmise à jour de Samba .."
os.system("smbpasswd -w "+new_pass)

# redémarrage des services
os.system("/etc/init.d/slapd restart")
#os.system("service samba restart")

